SystemOrganization addCategory: #HoHeCollections!

!ClassDescription methodsFor: '*hohecollections' stamp: 'OzC 3/10/2012 22:30'!
isSubclassOf: cls
	(self = cls or: [cls = Object]) ifTrue: [^ true].
	(self  = Object) ifTrue: [^ false].
	^ self superclass isSubclassOf: cls! !

!ClassDescription methodsFor: '*hohecollections' stamp: 'OzC 3/10/2012 22:22'!
leastCommonSuperclass: cls
	(self isSubclassOf: cls) ifTrue: [^ cls].
	(cls isSubclassOf: self) ifTrue: [^ self].
	^ self superclass leastCommonSuperclass: cls superclass  ! !

!FileStream class methodsFor: '*hohecollections' stamp: 'OzC 3/9/2012 13:26'!
writeAsCsv: ls on: fileName
	^ self forceNewFileNamed: fileName do:[:stream |
		ls do: [:ss | stream nextPutAll: ss asCommaString withoutQuoting ; cr  ]]   ! !

Object subclass: #HHCollections
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoHeCollections'!

!HHCollections class methodsFor: 'as yet unclassified' stamp: 'ozc 1/16/2015 11:52'!
exportCollectionAvg: n
	[ FileStream writeAsCsv: (self flatCollectionAvg: n) on: 'hohe-avg.csv'  ] fork.
	! !

!HHCollections class methodsFor: 'as yet unclassified' stamp: 'ozc 1/16/2015 12:15'!
flatCollectionAvg: n
	|flat delay|
	delay := Delay forSeconds: 10.  
	flat := OrderedCollection newFrom: {{'total-coll' .  'total-strict' . 'total-hetero' . 'total-relaxed' . 'total-elems'}}.
	(1 to: n) do: [:i|  |table tco tst the trl tel|
		table := self flatCollectionInstances. "{'Type' . 'Collections' . 'Length' . 'Homo-strict' . 'Hetero-strict' . 'Hetero' . 'Elems'}"
		table removeAt: 1. "remove header"
		tco:= 0.  tst:=0. the:=0. trl:=0. tel:=0.
		table do: [:row | 
			tco:= tco + (row at: 2). 		tst:= tst + (row at: 4). 	the:= the + (row at: 5).
			trl:= trl + (row at: 6). 		tel:= tel + (row at: 7).
			].
		
		flat add: {tco . tst . the . trl . tel}.
		delay wait.
		] displayingProgress: 'Gathering data'.
	^ flat  
	! !

!HHCollections class methodsFor: 'as yet unclassified' stamp: 'ozc 1/16/2015 11:49'!
flatCollectionInstances
	|flat|
	flat := OrderedCollection newFrom: {{'Type' . 'Collections' . 'Length' . 'Homo-strict' . 'Hetero-strict' . 'Hetero' . 'Elems'}}.
	Collection allSubclasses do: [:cls | |is row|
		is:= cls allInstances.
		is notEmpty ifTrue:[
					[ |elems |
					 elems := (is collect: #size).
					flat add:{ cls name . is size . elems average asFloat . 
				(is select: #isStrictHomo) size . (is select: #isStrictHetero) size .
				(is select: #isHetero) size . (elems inject: 0 into: [:acc :size| acc + size]) } ] on: Error do: [].  
				]
		] displayingProgress: 'Collecting instances'.
	^ flat  
 ! !

!HHCollections class methodsFor: 'as yet unclassified' stamp: 'OzC 3/10/2012 22:19'!
leastCommonSuperclass: array
	array isEmpty ifTrue: [^ nil].  
	^ array inject: (array first) into: [:sp :cls | sp leastCommonSuperclass: cls]    ! !

!Collection methodsFor: '*hohecollections' stamp: 'OzC 3/10/2012 22:43'!
isHetero
	^ (HHCollections leastCommonSuperclass: (self collect: #class)) = Object! !

!Collection methodsFor: '*hohecollections' stamp: 'OzC 3/10/2012 22:41'!
isHomo
	^ self isHetero not! !

!Collection methodsFor: '*hohecollections' stamp: 'OzC 3/10/2012 22:40'!
isStrictHetero
	|type|
	self do: [:obj | 
		type isNil ifTrue: [type:= obj class] ifFalse: [ (obj isMemberOf: type) ifFalse: [^true]]].
	^ false! !

!Collection methodsFor: '*hohecollections' stamp: 'OzC 3/10/2012 22:41'!
isStrictHomo
	^ self isStrictHetero not! !

TestCase subclass: #HHTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoHeCollections'!

!HHTests methodsFor: 'as yet unclassified' stamp: 'OzC 3/10/2012 22:35'!
testLCS
	self assert: (Integer leastCommonSuperclass: Number ) = Number.
	self assert: (Integer leastCommonSuperclass:  Object ) = Object.
	
	self assert:    (Integer leastCommonSuperclass:    Fraction  ) = Number.
	self assert:    (Integer leastCommonSuperclass:    String ) = Object.! !

!HHTests methodsFor: 'as yet unclassified' stamp: 'OzC 3/10/2012 22:36'!
testLCS2
	self assert: (HHCollections leastCommonSuperclass: {  Fraction . Integer . Number} ) = Number.
	self assert: (HHCollections leastCommonSuperclass: {  Fraction . Integer . String} ) = Object.
! !

!HHTests methodsFor: 'as yet unclassified' stamp: 'OzC 3/10/2012 22:34'!
testSubclass
	self assert: (Integer isSubclassOf: Number ).
	self assert: (Integer isSubclassOf: Object ).
	
	self deny: (Integer isSubclassOf: Fraction  ).
	self deny: (Integer isSubclassOf: String ).! !
